# -*- coding: utf-8 -*-
"""
Created on Tue Aug 18 11:34:27 2020

@author: farlarob
"""

import h5py
import numpy as np
import tkinter as tk
from tkinter import Tk
from tkinter.filedialog import askopenfilenames
from tkinter.simpledialog import askstring
from tkinter import messagebox
import os

root = Tk()
root.withdraw()
root.wm_attributes('-topmost', 1)

Tk().withdraw() # we don't want a full GUI, so keep the root window from appearing
filenames = askopenfilenames(parent=root,title='Choose multiple files') # show an "Open" dialog box and return the path to the selected file

lst = list(filenames)

root2 = tk.Tk()
root2.withdraw()
root2.wm_attributes('-topmost', 1)
Channel = askstring("input","Enter number of channels used ('0','1' or 'both'), where detector 1 = 1 & detector 2 = 0 : ")

if Channel == '0':
    for i in lst:   

        f = h5py.File(i, 'r')
        
        try:
            dset = f['/entry/instrument/xspress3/channel00/histogram']
        except KeyError:
            messagebox.showerror("Error","Channel does not exist")
                    
        dset_transpose = np.transpose(dset)
    
        dset_corr = np.delete(dset_transpose, 4095, 0)
        
        dset_corr2 = np.sum(dset_corr, axis = 1)
            
        #num_rows = dset_corr2.shape
        #print(num_rows)
        
        new_column = np.arange(0,4095)
          
        dset_fix = np.column_stack((new_column,dset_corr2))
                
        output = os.path.basename(i)
        pre, ext = os.path.splitext(i)
        
        output = pre + '_Ch0' + '.csv'
        
        np.savetxt(output, dset_fix, delimiter=",")
        
    messagebox.showinfo("Conversion", "The nxs to csv conversion is complete")        

if Channel == '1':
    for i in lst:
    
        f = h5py.File(i, 'r')
        
        try:
            dset = f['/entry/instrument/xspress3/channel01/histogram']
        except KeyError:
            messagebox.showerror("Error","Channel does not exist")
            
        dset_transpose = np.transpose(dset)
    
        dset_corr = np.delete(dset_transpose, 4095, 0)
        
        dset_corr2 = np.sum(dset_corr, axis = 1)
            
        #num_rows = dset_corr2.shape
        #print(num_rows)
        
        new_column = np.arange(0,4095)
          
        dset_fix = np.column_stack((new_column,dset_corr2))
                
        output = os.path.basename(i)
        pre, ext = os.path.splitext(i)
        
        output = pre + '_Ch1' + '.csv'
        
        np.savetxt(output, dset_fix, delimiter=",")

    messagebox.showinfo("Conversion", "The nxs to csv conversion is complete")          
        
if Channel == 'both':
    for i in lst:   
    
        f = h5py.File(i, 'r')
        
        try: 
            dset = f['/entry/instrument/xspress3/channel00/histogram']
        except KeyError:
            messagebox.showerror("Error","Channel does not exist")
          
        dset_transpose = np.transpose(dset)
        
        dset_corr = np.delete(dset_transpose, 4095, 0)
            
        dset_corr2 = np.sum(dset_corr, axis = 1)
                
        #num_rows = dset_corr2.shape
        #print(num_rows)
            
        new_column = np.arange(0,4095)
              
        dset_fix = np.column_stack((new_column,dset_corr2))
                    
        output = os.path.basename(i)
        pre, ext = os.path.splitext(i)
           
        output = pre + '_Ch0' + '.csv'
            
        np.savetxt(output, dset_fix, delimiter=",")     
            
    for i in lst:
    
        f = h5py.File(i, 'r')
        
        try:
            dset = f['/entry/instrument/xspress3/channel01/histogram']
        except KeyError:
            messagebox.showerror("Error","Channel does not exist")
             
        dset_transpose = np.transpose(dset)
    
        dset_corr = np.delete(dset_transpose, 4095, 0)
        
        dset_corr2 = np.sum(dset_corr, axis = 1)
            
        #num_rows = dset_corr2.shape
        #print(num_rows)
        
        new_column = np.arange(0,4095)
          
        dset_fix = np.column_stack((new_column,dset_corr2))
                
        output = os.path.basename(i)
        pre, ext = os.path.splitext(i)
        
        output = pre + '_Ch1' + '.csv'
        
        np.savetxt(output, dset_fix, delimiter=",")
        
    messagebox.showinfo("Conversion", "The nxs to csv conversion is complete")  